// 24bitPointerGrabber v1.0
// Coded by DaMarsMan 2006
// Kojiro Translations
#define false 0
#define true 1
#include <fstream>
#include <iomanip>
#include <iostream>
#include <stdio.h>
#include <tchar.h>
#include <malloc.h>

#define null '\0'
#ifndef dwrd
 typedef unsigned char  byte;
 typedef unsigned short word;
 typedef unsigned long  dwrd;
#endif


using namespace std;

//Global Variable Declarations
fstream rom_file;
dwrd start;
int block_count;
byte pointer;
signed int adjust;

// Prototypes
int HexString2Integer(const TCHAR *value);

int main(int argc, char *argv[]) 
{
	if (argc!=5)
	{
		printf("PascalAdjust v1.0....\nUsage: PascalAdjust <Rom.ext> <StartOffset> <BlockCount> <AdjustAmount>\nExample: PascalAdjust rom.smc 8000 32 1\nThe starting offset should be in hex format without 0x!\n\n");
	}
	else
	{
    rom_file.open(argv[1], ios::in | ios::out | ios::binary);
	start = HexString2Integer(argv[2]);	//convert hex string to int
	block_count = atoi(argv[3]);
	adjust = atoi(argv[4]);
	
	int c=0;
	while(true) {
      rom_file.seekg(start, ios::beg); // seek to first pascal pointer
      pointer = rom_file.get();
      //cout<<hex<<(int)pointer;
      rom_file.seekg(start, ios::beg); // seek to first pointer
      start+=(int)pointer+1;           // increment to next for next loop
      pointer+=(int)adjust; //cout<<"   "<<hex<<(int)pointer<<endl;
      rom_file.put(pointer);
      c++;
      if (c>block_count) break;
    }
	
	rom_file.close();
	}
	
	return 0;
}




int HexString2Integer(const TCHAR *value)
{
  struct CHexMap
  {
    TCHAR chr;
    int value;
  };
  const int HexMapL = 16;
  CHexMap HexMap[HexMapL] =
  {
    {'0', 0}, {'1', 1},
    {'2', 2}, {'3', 3},
    {'4', 4}, {'5', 5},
    {'6', 6}, {'7', 7},
    {'8', 8}, {'9', 9},
    {'A', 10}, {'B', 11},
    {'C', 12}, {'D', 13},
    {'E', 14}, {'F', 15}
  };
  TCHAR *mstr = _tcsupr(_tcsdup(value));
  TCHAR *s = mstr;
  int result = 0;
  if (*s == '0' && *(s + 1) == 'X') s += 2;
  bool firsttime = true;
  while (*s != '\0')
  {
    bool found = false;
    for (int i = 0; i < HexMapL; i++)
    {
      if (*s == HexMap[i].chr)
      {
        if (!firsttime) result <<= 4;
        result |= HexMap[i].value;
        found = true;
        break;
      }
    }
    if (!found) break;
    s++;
    firsttime = false;
  }
  free(mstr);
  return result;
}
